package com.networksByteDesign.util;

import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.types.*;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;
import java.util.Enumeration;

public class EssTask extends MatchingTask
{
    public void execute()
    {
        // Get a handle on the Directory Scanner
        log("Enter execute()", Project.MSG_INFO);
        DirectoryScanner ds = fileset_.getDirectoryScanner(project);
        String fileSeparator = System.getProperty("file.separator");
        String absPath = (fileset_.getDir(project)).toString() + fileSeparator;
        log("fileset_.getDir = " + fileset_.getDir(project), Project.MSG_DEBUG);
        
        // Get the list of files and write them to the temp file
        String listFileName = absPath + tempfile_;
        
        FileWriter fw = null;
        try
        {
            fw = new FileWriter(new File(listFileName));
            String[] includedFiles = ds.getIncludedFiles();
            for (int j=0; j<includedFiles.length; j++)
            {
                fw.write(absPath + includedFiles[j] + "\n");
                log("add file: " + absPath + includedFiles[j], Project.MSG_DEBUG);
            }
        }
        catch (Exception e)
        {
            log(e.getMessage(), Project.MSG_ERR);
        }
        finally
        {
            try
            {
                fw.close();
            }
            catch (IOException e) {}
        }
        
        // Get a handle on the JVM Runtime Object
        Runtime rt = Runtime.getRuntime();
        
        // Set up arguments
        log("listFileName = " + listFileName, Project.MSG_DEBUG);
        String newListFile = listFileName.replace('/', '\\');
        String cmd = "essmodel.exe @" + newListFile + " -d" + destdir_;
        
        // Execute the tool
        try
        {
            rt.exec(cmd);
        }
        catch (IOException e)
        {
            log(e.getMessage(), Project.MSG_ERR);
        }
        log("Exit execute()", Project.MSG_INFO);
    }

    public void addFileset(FileSet set)
    {
        log("Enter addFileset(FileSet set)", Project.MSG_DEBUG);
        fileset_ = set;
        log("fileset_ = " + fileset_, Project.MSG_DEBUG);
        log("Exit addFileset(FileSet set)", Project.MSG_DEBUG);
    }
    
    public void setDestdir(String destdir)
    {
        log("Enter setDestdir(String destdir)", Project.MSG_DEBUG);
        destdir_ = destdir.replace('/', '\\');
        log("destdir = " + destdir, Project.MSG_DEBUG);
        log("Exit setDestdir(String destdir)", Project.MSG_DEBUG);
    }
    
    private FileSet fileset_;
    private String  destdir_ = null;
    private String  tempfile_ = "tempFile";
}
