package com.networksByteDesign.util;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.regexp.RegexpMatcher;
import org.apache.tools.ant.util.regexp.RegexpMatcherFactory;

public class RegexpInput extends RequiredInput
{
    /**
     * Sets the pattern to match the user's input during the build run.
     * @param pattern The pattern to match.
     */
    public void setPattern(String pattern)
    {
        pattern_     = pattern;
        havePattern_ = true;
    }
    
    /**
     * Actual test method executed by jakarta-ant.
     * @exception BuildException
     */
    public void execute () throws BuildException
    {
        if (!havePattern_)
        {
            throw new 
                BuildException
                ("Required attribute pattern not set in regexpInput",
                 location);
        }

        super.execute();
        
        RegexpMatcherFactory factory = new RegexpMatcherFactory();
        RegexpMatcher        regexp  = factory.newRegexpMatcher();
        
        regexp.setPattern(pattern_);
        
        if(! regexp.matches(getProject().getProperty(getProperty())))
        {
            throw new BuildException(getErrormessage(), location);
        }
    }
    
    private String  pattern_       = "";
    private boolean havePattern_   = false;
}
