package com.networksByteDesign.eMarket.util;

import java.io.IOException;
import java.io.Writer;
import java.text.DateFormat;
import java.util.Date;
import java.util.Hashtable;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;


/**
 * @jsp:tag name="eMarket"
 *          tei="eMarketTagLib"
 *          body-content="JSP"
 *          description="eMarket Tag Libs"
 */
public class TagLib implements BodyTag
{
    protected BodyContent bodyOut_;
    protected PageContext pageContext_;
    protected Tag parent_;
    private String[] atts_ = new String[1];
    int i = 0;

    private final void setAtt(int index, String value)
    {
        atts_[index] = value;
    }

    public void setAtt1(String value)
    {
        setAtt(0, value);
    }

    public void setParent(Tag parent)
    {
        parent_ = parent;
    }

    public void setBodyContent(BodyContent bodyOut)
    {
        bodyOut_ = bodyOut;
    }

    public void setPageContext(PageContext pageContext)
    {
        pageContext_ = pageContext;
    }

    public Tag getParent()
    {
        return parent_;
    }

    public int doStartTag() throws JspException
    {
        return EVAL_BODY_BUFFERED;
    }

    public int doEndTag() throws JspException
    {
        return SKIP_BODY;
    }

    public void doInitBody() throws JspException
    {
        pageContext_.setAttribute("date", getDate());
    }

    public int doAfterBody() throws JspException
    {
        try
        {
            if(i == 0)
            {
                bodyOut_.writeOut(bodyOut_.getEnclosingWriter());

                return SKIP_BODY;
            }
            else
            {
                pageContext_.setAttribute("date", "bar");
            }

            i++;

            return EVAL_BODY_BUFFERED;
        }
        catch(IOException ex)
        {
            throw new JspTagException(ex.toString());
        }
    }

    public void release()
    {
        bodyOut_ = null;
        pageContext_ = null;
        parent_ = null;
    }

    private String getDate()
    {
        return DateFormat.getDateInstance().format(new Date());
    }
}
